# This file is a template, and might need editing before it works on your project.
image: golang:latest

variables:
  # Please edit to your GitLab project #### EDITED 
  REPO_NAME: gitlab.com/dnsmichi/meetup-2020-cw13

# The problem is that to be able to use go get, one needs to put
# the repository in the $GOPATH. So for example if your gitlab domain
# is gitlab.com, and that your repository is namespace/project, and
# the default GOPATH being /go, then you'd need to have your
# repository in /go/src/gitlab.com/namespace/project
# Thus, making a symbolic link corrects this.
before_script:
  - mkdir -p $GOPATH/src/$(dirname $REPO_NAME)
  - ln -svf $CI_PROJECT_DIR $GOPATH/src/$REPO_NAME
  - cd $GOPATH/src/$REPO_NAME

#### EDITED
stages:
  - test
  - coverage
  - build
  - deploy

format:
  stage: test
  script:
    - go mod init
    - go fmt $(go list ./... | grep -v /vendor/)
    - go vet $(go list ./... | grep -v /vendor/)
    - go test -race $(go list ./... | grep -v /vendor/)

#### EDITED
coverage:
  stage: coverage
  script:
    - go test -cover $(go list ./... | grep -v /vendor/)    

#### EDITED
compile:
  stage: build
  script:
    - go mod init
    - go build -race -ldflags "-extldflags '-static'" -o $CI_PROJECT_DIR/tanuki
  artifacts:
    paths:
      - tanuki 

#### EDITED
run:
  stage: deploy
  script:
    - ./tanuki      
